import socket
import pickle

class Proxy(object):
	def __init__(self,serverAddress,port):
		self.serverAddress = serverAddress
		self.port = port

	def servidor(self):				
		#Creo el objeto socket
		s = socket.socket()
		#Invoco al metodo bind, pasando como parametro una tupla con IP y puerto
		s.bind((self.serverAddress, self.port))
		#Invoco el metodo listen para escuchar conexiones con el numero maximo de conexiones
		s.listen(1)
		while (1):
			#El metodo accept bloquea la ejecucion a la espera de conexiones
			#accept devuelve un objeto socket y una tupla Ip y puerto
			sc, addr = s.accept()
			print "Recibo conexion de " + str(addr[0]) + ":" + str(addr[1])
	 		#invoco recv sobre el socket cliente, para recibir un maximo (segun parametro)
  			recibido = sc.recv(1024)
			m = pickle.loads(recibido)#Deserializamos el mensaje
			funcexecutar = getattr(self.objeto,m.funcio)
			if len(m.parametres) > 0:
				sc.send(pickle.dumps(funcexecutar(*m.parametres)))#Enviamos el resultado serializado
			else:
				sc.send(pickle.dumps(funcexecutar()))		
		#cierro sockets cliente y servidor
		sc.close()
		s.close()
		return 5
	def registrar(self,Objeto,Nombre):
		self.objeto = Objeto
		return 5
