#Servidor de nombres que nos permite registrar objetos remotos con paso de referencia.
import proxyServidor
import proxyClient

class sn():
	def __init__(self):
		self.taula_ref = {}
	
	#Funcion que devuelve la referencia remota de un objeto a partir de su nombre	
	def loockup(self, nom):
		if nom in self.taula_ref:
			return self.taula_ref[nom]
		else:
			return -1
	#Funcion que registra la referencia remota de un objeto remoto con un nombre	
	def bind(self,nom,ref):
		self.taula_ref[nom] = ref
		return "Funcion registrada"


s = proxyServidor.Proxy("localhost", 1234)
#registramos el objeto sn
s.registrar(sn(),"sn")
#Iniciamos el servidor de nombres
s.servidor()
